'
' DotNetNukeŽ - http://www.dotnetnuke.com
' Copyright (c) 2002-2006
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Namespace DotNetNuke.Modules.IWeb

    Public Class IWebUserInfo
        Private Shared Function GetPassword(ByVal parmPassword As String, ByVal PortalID As Integer, ByVal parmEncrypted As Boolean) As String

            Dim strPassword As String = ""
            If parmEncrypted Then
                strPassword = HttpUtility.UrlDecode(parmPassword)
                ' Get the Encryption Key
                Dim strEncryptionKey As String = IWebController.GetIWebSettings(PortalID, "SecurityKey")
                ' Un-encrypt the password
                Dim objIWebEncryption As New IWebEncryption()
                strPassword = objIWebEncryption.DeCrypt(strPassword, strEncryptionKey)
            Else
                strPassword = parmPassword
            End If
            Return strPassword

        End Function
        Public Shared Function GetUserInfo(ByVal PortalID As Integer, ByVal Username As String, ByVal Password As String, ByVal Encrypted As Boolean) As UserInfo
            Dim strPassword As String = ""
            strPassword = GetPassword(Password, PortalID, Encrypted)
            Dim loginStatus As Security.Membership.UserLoginStatus
            Return UserController.ValidateUser(PortalID, Username, strPassword, "", "", "255.255.255.1", loginStatus)
        End Function

        Public Shared Function IsAuthorized(ByVal UserInfo As UserInfo, ByVal IWebInfo As IWebInfo) As Boolean
            Dim RoleController As Security.Roles.RoleController = New Security.Roles.RoleController
            Dim strRoles As String() = RoleController.GetRolesByUser(UserInfo.UserID, UserInfo.PortalID)
            Dim strRole As String

            If UserInfo.IsSuperUser Then
                Return True
            End If

            For Each strRole In strRoles
                If strRole = IWebInfo.Setting Then
                    Return True
                End If
            Next strRole

            Return False

        End Function

    End Class

End Namespace

